
// This code was tested in an SPC emulator and passed test_div.spc

struct result_t
{
	int y;
	int a;
	int v;
};

result_t spc_div( int y, int a, int x )
{
	result_t r;
	unsigned ya = y * 0x100 + a;
	
	r.v = (y >= x);
	
	if ( y < x * 2 )
	{
		a = ya / x;
		y = ya % x;
	}
	else
	{
		a = 255 - (ya - x * 0x200) / (256 - x);
		y = x   + (ya - x * 0x200) % (256 - x);
	}
	
	r.y = y & 0xff;
	r.a = a & 0xff;
	
	return r;
}
