
; Short delay
delay:
      push  a
      mov   a,#0
-     dec   a
      bne   -
      pop   a
      ret

; Start continuous tone
start_tone:
      call  !init_dsp
      write kon,$01     
      ret

; Play 'a' short beeps
make_beeps:
      push  a
      call  !init_dsp
      pop   a
beep_loop:
      write kon,$01
      mov   x,#20
-     call  !delay
      dec   x
      bne   -
      write koff,$01
      
      dec   a
      bne   +
      ret
+

      mov   x,#100
-     call  !delay
      dec   x
      bne   -
      
      write koff,$00
      call  !delay
      
      jmp   !beep_loop
      
; Initialize DSP and set up sample
init_dsp:
      write flg,$20     ; un-mute
      write kon,$00     ; key off all voices
      write koff,$ff
      call  !delay
      
      write koff,$00    ; key off
      
      mov   a,#<sample  ; set up sample
      mov   y,#>sample
      mov   !$800,a
      mov   !$801,y
      mov   a,#<sample_loop
      mov   y,#>sample_loop
      mov   !$802,a
      mov   !$803,y
      
      write dir,$08     ; directory
      
      write $00,$7f     ; volume
      write $01,$7f
      write $02,$00     ; pitch
      write $03,$02
      write $04,$00     ; instrument
      write $05,$00     ; adsr off
      write $06,$00
      write $07,$7f     ; gain = $7f
      
      write nov,$00     ; noise off
      write eov,$00     ; echo off
      write mvoll,$7f
      write mvolr,$7f
      write evoll,$00
      write evolr,$00
      
      ret
      
sample:
sample_loop:
      .db     $b0,$78,$78,$78,$78,$78,$78,$78,$78
      .db     $b3,$78,$78,$78,$78,$78,$78,$78,$78

